Subject: Re: [Netconf] yang push: push-change-update for leaf-lists

From: "Sterne, Jason (Nokia - CA/Ottawa)" <[email-masked]>
Date: Tue, 3 Apr 2018 13:25:05 +0000

Thanks Eric.

I assume that behavior (not sending test1 & test3) is generally true for YANG Patch (RFC8072) in general (even outside of this particular yang push application of yang patch).

Redundant operation indicators:

>     <operation>merge</operation>         <-----
>     <target>/foo-ns:foo</target>
>     <value>
>       <foo xmlns="urn:foo.com:foo"
>            nc:operation="merge"     <-------
>            yang:insert="after"
>            yang:value="test1">test2</foo>
>     </value>

Rgds,
Jason

> -----Original Message-----
> From: Eric Voit (evoit) [mailto:[email-masked]]
> Sent: Friday, March 30, 2018 7:16 PM
> To: Sterne, Jason (Nokia - CA/Ottawa) <[email-masked]>;
> Alexander Clemm <[email-masked]>
> Cc: [email-masked]
> Subject: RE: yang push: push-change-update for leaf-lists
> 
> Hi Jason,
> 
> You are correct that test1 & test3 are not sent for the insert you describe
> below.
> 
> I am not exactly sure what you mean by "redundant operation indicators".
> Could you explain?
> 
> Eric
> 
> 
> -----------------------------
> From: Sterne, Jason, March 29, 2018 12:45 PM
> 
> Hi guys,
> 
> The yang push drafts reference the yang patch RFC for the format of a push-
> change-update (i.e. on-change).
> 
> If a user-ordered leaf-list (of strings) 'foo' (at the root) contains 2 entries
> 'test1' and 'test3', and a collector is subscribed to the configuration tree, and
> a client adds 'test2' to the leaf-list after 'test1', then I assume the push-
> change-update would contain just that one entry 'test2' right ?
> 
>     <operation>merge</operation>
>     <target>/foo-ns:foo</target>
>     <value>
>       <foo xmlns="urn:foo.com:foo"
>            nc:operation="merge"
>            yang:insert="after"
>            yang:value="test1">test2</foo>
>     </value>
> 
> From what I understand, the entire contents of the leaf-list (i.e. 'test1',
> 'test2' and 'test3' are *not* sent for an addition (or deletion) of a single
> entry.
> 
> As a secondary question/note -> don't we end up with redundant operation
> indicators (which could differ if an implementation had a bug) ?
> 
> Rgds,
> Jason